//
//  WFTopLevelFoldersEnumerator.m
//  DemoSomeFiles
//
//  Created by Amy Worrall on 04/09/2017.
//  Copyright © 2017 Amy Worrall. All rights reserved.
//

#import "WFTopLevelFoldersEnumerator.h"
#import "FoldersGrabber.h"
#import "FileProviderItem.h"

@implementation WFTopLevelFoldersEnumerator

- (instancetype)initWithEnumeratedItemIdentifier:(NSFileProviderItemIdentifier)enumeratedItemIdentifier {
  if (self = [super init]) {
    _enumeratedItemIdentifier = enumeratedItemIdentifier;
  }
  return self;
}

- (void)invalidate {
  // TODO: perform invalidation of server connection if necessary
}

- (void)enumerateItemsForObserver:(id<NSFileProviderEnumerationObserver>)observer startingAtPage:(NSFileProviderPage)page {

  if ([_enumeratedItemIdentifier isEqualToString:NSFileProviderRootContainerItemIdentifier]) {

    FoldersGrabber *grabber = [[FoldersGrabber alloc] init];

    __weak typeof(grabber) weakGrabber = grabber;
    grabber.completionBlock = ^{
      NSMutableArray *fileProviderItems = [NSMutableArray new];
      for (NSDictionary *folderNode in weakGrabber.folders) {
        FileProviderItem *folderProviderItem =
        [[FileProviderItem alloc] initFolderWithFolderID:folderNode[@"id"]
                                                    name:folderNode[@"name"]];
        [fileProviderItems addObject:folderProviderItem];

        [self.delegate setEntry:folderProviderItem forFBID:folderNode[@"id"]];
      }

      [observer didEnumerateItems:fileProviderItems];
      [observer finishEnumeratingUpToPage:nil];
    };

    [[NSOperationQueue mainQueue] addOperation:grabber];
  }

}

@end
